Subject: How to avoid kernel's receive buff full , then UDP packet dropped by kernel?

From: Jiuhai Zhang <[email-masked]>
Date: Fri, 29 Nov 2019 20:52:57 +0800

Is there any good idea to solve this? How can we do flow control like TCP
receive window size? User space can not get how many receive buff is used

---

From: Ryan Hamilton <[email-masked]>
Date: Fri, 29 Nov 2019 15:52:24 -0800

On the server side of a QUIC connection, the UDP socket (and hence the
kernel receive buffer) is shared across multiple connections. As such it'd
be incredibly complicated to come up with a system to handle this and would
likely result in unnecessarily throttling throughput. On the client side
(where there is once QUIC connection per socket) this is unlikely to happen
if the receive buffer is larger than the BDP of the link. Of course, in
reality, if the application is reading from the socket frequently enough,
this is likely a non-issue.